module NQueens
    ( nQueens
    ) where


import Data.Bits
import qualified Data.Map as Map
import Control.Parallel.Strategies(using, parList, rseq, r0)


type Board = [Word]


nQueens :: Int -> Int -> Int
nQueens n dep = count $ replicate n 0
  where
    mask = (bit n) - 1 :: Word

    occupyBoard = Map.fromAscList [ (x, occupy bitx bitx bitx)
                                  | x <- [0..n-1], let bitx = bit x ]
      where
        occupy c l r = (c .|. l' .|. r') : occupy c l' r'
          where l' = shiftL l 1
                r' = shiftR r 1
    
    count [] = 1
    count (row:rows) = sum (nums `using` strat)
      where
        nums = map count $ filter feasible boards
        strat
          | n - dep > length rows = r0
          | otherwise             = parList rseq
    
        boards = map placeQueenAt $ filter (not . testBit row) [0..n-1]
        feasible b = rowsFeasible && columnsFeasible
          where 
            rowsFeasible = notElem mask $ map (.&. mask) b
            columnsFeasible = n >= length b + (popCount $ foldr (.&.) mask b)

        placeQueenAt x = zipWith (.|.) rows $ occupyBoard Map.! x
